%This script runs the SOC thermostatic contol model
close all
clear
clc

%Load parameters necessary to run simulation
%This includes battery parameters and operating points/maps found in the
%optimization script from Module 3

load('Initialize.mat')

t_end=2500;    %Simulation time

P_tractive=25e3;  %Tractive motor power (W)

SOC_init=20;   %Set a starting SOC
Pct_deplete_up=92;   %Upper Bound of SOC hysteresis band
Pct_deplete_dwn=88;   %Lower Bound of SOC hysteresis band

sim('SOC_thermostatic')

%Plot important results
figure
plot(time,SOC)
title('SOC Using Thermostatic Control')
xlabel('Time (s)')
ylabel('SOC')

figure
plot(time,T_req)
title('Engine Torque Requested by Thermostatic Controller')
xlabel('Time (s)')
ylabel('Torque (Nm)')

figure
plot(time,N_req)
title('Generator Speed Requested by Thermostatic Controller')
xlabel('Time (s)')
ylabel('Speed (RPM)')

figure
plot(time,T_eng)
title('Actual Engine Torque')
xlabel('Time (s)')
ylabel('Torque (Nm)')

figure
plot(time,N_gen)
title('Actual Generator Speed')
xlabel('Time (s)')
ylabel('Speed (RPM)')
